#include <stdio.h>
#include <stdlib.h>

void doInput(int nCount, int *pHeight, int *pWeight);
void calcBMI(int nCount, int *pHeight, int *pWeight, double *pBMI);
double getAverageBMI(int nCount, double *pBMI) ;

int main()
{
	int		nCount = 0; 
	int		*pHeight = NULL;
	int		*pWeight = NULL;
	double		*pBMI = NULL;
	double	lAverage = 0;

	do {
		printf("ȸ ? (0   Էϸ ˴ϴ): ");
		scanf("%d", &nCount);

		if (nCount > 0) {
			pHeight = (int*)malloc(sizeof(int) * nCount);
			pWeight = (int*)malloc(sizeof(int) * nCount);
			pBMI = (double*)malloc(sizeof(double) * nCount);
			if (NULL != pBMI && NULL != pHeight && pWeight) {
				doInput(nCount, pHeight, pWeight);
				calcBMI(nCount, pHeight, pWeight, pBMI);
				lAverage = getAverageBMI(nCount, pBMI);
				
				printf(" ü %fԴϴ\nٽ ȸ Էϼ\n",
					lAverage);
			}
			else {
				printf("޸ Ҵ翡 ߽ϴ.");
			}
			if (NULL != pBMI) free( pBMI );
			if (NULL != pHeight) free( pHeight );
			if (NULL != pWeight) free( pWeight );
		}
	} while(nCount > 0);

	return 0;
}

void doInput(int nCount, int *pHeight, int *pWeight) 
{
	int		i = 0;
	int		nHeight = 0, nWeight = 0;
	if (nCount > 0 && NULL != pHeight && NULL != pWeight) {
		for(i = 0; i < nCount; i++) {
			printf("Ű: ");
			scanf("%d", &nHeight);
			printf(": ");
			scanf("%d", &nWeight);

			if (nHeight > 0 && nWeight > 0) {
				*(pHeight+i) = nHeight;
				*(pWeight+i) = nWeight;
			}
			else {
				printf("%d° , Ű: %d, : %d,  0 Ŀ մϴ\n",
					(i+1), nHeight, nWeight); 
			}
		}
	}
	else {
		printf("doInput(): Է ĶͿ  ֽϴ\n");
	}
}

void calcBMI(int nCount, int *pHeight, int *pWeight, double *pBMI) 
{
	int		i = 0;
	int		nHeight = 0, nWeight = 0;
	if (nCount > 0 && NULL != pHeight && NULL != pWeight && NULL != pBMI) {
	for(i = 0; i < nCount; i++) {
	nHeight = *(pHeight + i);
	nWeight = *(pWeight + i);
	if (nHeight > 0 && nWeight > 0) {
			*(pBMI+i) = (double)nHeight / nWeight;
			printf("%d° , Ű: %d, : %d => ü %f\n",
				(i+1), nHeight, nWeight, *(pBMI+i));
			}
		}
	}
	else {
		printf("calcBMI(): Է ĶͿ  ֽϴ\n");
	}
}

double getAverageBMI(int nCount, double *pBMI) {
	double	lResult = 0;
	int		i = 0;
	if (nCount > 0 && NULL != pBMI) {
			for(i = 0; i < nCount; i++) {
				lResult += *(pBMI+i);
			}
			lResult = lResult / nCount;
		}
		else {
			printf("calcAverage(): Է ĶͿ  ֽϴ\n");
	}
	return lResult;
}
