#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int alloc_dyn_array(int size, double default_value, int** ppResult);

int main()
{
	int size = 0, i = 0, errcode = 0;
	double *pdouble_array = NULL;	

	printf(" ? (0 Ŀմϴ) ");
	scanf("%d", &size);

	if (size <= 0) 
	{
		printf("0 Ŀմϴ.\n");
		return 0;
	}
	
	errcode = alloc_dyn_array(size, 0, &pdouble_array);
	if (0 == errcode) {
		for(i = 0; i < size; i++) 
		{
			printf("%d° ? ", i);
			scanf("%lf", &(pdouble_array[i]));
		}

		printf("Է    ϴ.\n");
		for(i = 0; i < size; i++) 
		{
			printf("%d°: %.2f\n", i, pdouble_array[i]);
		}
	}

	return 0;
}

int alloc_dyn_array(int size, double default_value, int** ppResult)
{
	int		result = 0;
	int*	pArray = NULL;
	if (size > 0 && NULL != ppResult)
	{
		pArray = (int*)malloc(sizeof(int) * size);
		if (NULL != pArray) 
		{
			memset(pArray, default_value, sizeof(int) * size);
			*ppResult = pArray;
		}
		else 
		{
			result = 1;
			printf(": ޸ Ҵ\n");
		}
	}
	else 
	{
		result = 2;
		printf(": Է Ķ\n");
	}
	return result;
}
