#include<stdio.h>

// type 1̸ int .
// type 2̸ char .
void get_max_values(void *parray, int count, int type, void** ppresult);

int main()
{
	int		int_values[] = { 10, 20, 30, 40 };
	int		*pint_max_value = NULL;

	char	char_values[] = { 'C', 'A', 'Z', 'D' };
	char	*pchar_max_value = NULL;

	int		element_count = 0;

	element_count = sizeof(int_values)/sizeof(int);
	get_max_values(int_values, element_count, 1, &pint_max_value);

	element_count = sizeof(char_values)/sizeof(char);
	get_max_values(char_values, element_count, 2, &pchar_max_value);

	if (NULL != pint_max_value) 
	{
		printf("int 迭 ִ밪: %d\n", *pint_max_value);
	}
	if (NULL != pchar_max_value) 
	{
		printf("char 迭 ִ밪: %c\n", *pchar_max_value);
	}
}

void get_max_values(void *parray, int count, int type, void** ppresult)
{
	int i = 0;
	char *pchar_array = NULL;
	char *pchar_max = NULL;
	int *pint_array = NULL;
	int *pint_max = NULL;

	if (NULL == parray || 0 == count || NULL == ppresult)
		return;

	if (1 == type) 
	{
		pint_max = pint_array = (int*)parray;
		for(i = 1; i < count; i++) 
		{
			if (pint_array[i] > (*pint_max)) 
			{
				pint_max = &(pint_array[i]);
			}
		}
		*ppresult = pint_max;
	}
	else if (2 == type) 
	{
		pchar_max = pchar_array = (char*)parray;
		for(i = 1; i < count; i++) 
		{
			if (pchar_array[i] > (*pchar_max)) 
			{
				pchar_max = &(pchar_array[i]);
			}
		}
		*ppresult = pchar_max;
	}
}
