#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct simple_student
{
    char    name[20];
    int     age;
    long    number;
    int     score;

	struct simple_student *pnext;
};

void add_student(struct simple_student *pstudents, struct simple_student student);
void print_student_info(struct simple_student* pstudent);

int main()
{
	struct simple_student students = {0};
	struct simple_student temp_student = {0};

	strcpy(temp_student.name, "ȫ浿");
	temp_student.age = 20;
	temp_student.number = 1001;
	temp_student.score = 90;
	add_student(&students, temp_student);

	strcpy(temp_student.name, "̿");
	temp_student.age = 19;
	temp_student.number = 1002;
	temp_student.score = 50;
	add_student(&students, temp_student);

	print_student_info(&students);
	return 0;
}

void add_student(struct simple_student *pstudents, struct simple_student student)
{
	struct simple_student *pfirst_student = NULL;
	struct simple_student *pnew_student = NULL;
	if (NULL != pstudents)
	{
		pfirst_student = pstudents->pnext;
		pnew_student = (struct simple_student *)malloc(sizeof(struct simple_student));
		if (NULL != pnew_student)
		{
			*pnew_student = student;
			pnew_student->pnext = NULL;

			pstudents->pnext = pnew_student;
			if (NULL != pfirst_student)
			{
				pnew_student->pnext = pfirst_student;
			}
		}
		else
		{
			printf("!!!add_student() mallc() ߽ϴ\n");
		}
	}
	else
	{
		printf("!!!add_student() NULL ޵Ǿϴ\n");
	}
}

void print_student_info(struct simple_student* pstudent)
{
	struct simple_student* pnext_student = NULL;
	if (NULL != pstudent)
	{
		pnext_student = pstudent->pnext;
		while(NULL!= pnext_student) 
		{
			printf("̸: %s\n: %d\nй: %ld\n: %d\n", 
				pnext_student->name, pnext_student->age, pnext_student->number, pnext_student->score);

			pnext_student = pnext_student->pnext;
		}
	}
	else
	{
		printf("!!!: print_student_info() NULL ޵Ǿϴ\n");
	}
}
