#include <stdio.h>
#include "my_struct.h"
#include "my_func_input.h"

void input_teachers_students(psimple_teacher pTeacher, int teacher_count, 
		psimple_student pStudent, int student_count)
{
	int i = 0;

	if (NULL == pTeacher || NULL == pStudent || teacher_count <= 0 || student_count <= 0)
		return;

	for(i = 0; i < teacher_count; i++)
	{
		input_teacher_info(&pTeacher[i]);
	}

	for(i = 0; i < student_count; i++)
	{
		input_student_info(&pStudent[i]);
	}

}

int input_teacher_student_count(int *pTeacher_count, int *pStudent_count)
{
	if (NULL == pTeacher_count || NULL == pStudent_count)
	{
		printf(" Ͱ ޵Ǿϴ\n");
		return 0;
	}

	printf(" ? ");
	scanf("%d", pTeacher_count);

	printf("л ? ");
	scanf("%d", pStudent_count);

	if (*pTeacher_count <= 0 || *pStudent_count <= 0)
	{
		printf("ڰ 0 Ŀմϴ\n");
		return 0;
	}

	return 1;
}

void input_teacher_info(psimple_teacher pTeacher)
{
	if (NULL != pTeacher)
	{
		printf(" ̸ Է: ");
		scanf("%s", pTeacher->name);

		printf("  Է: ");
		scanf("%d", &(pTeacher->age));

		printf("  Է: ");
		scanf("%ld", &(pTeacher->number));
	}
}

void input_student_info(psimple_student pStudent)
{
	if (NULL != pStudent)
	{
		printf("л ̸ Է: ");
		scanf("%s", pStudent->name);

		printf("л  Է: ");
		scanf("%d", &(pStudent->age));

		printf("л й Է: ");
		scanf("%ld", &(pStudent->number));
	}
}