#include <stdio.h>
#include "my_struct.h"
#include "my_func_print.h"

void print_teachers_students(psimple_teacher pTeacher, int teacher_count, psimple_student pStudent, int student_count)
{
	int i = 0;

	if (NULL == pTeacher || NULL == pStudent || teacher_count <= 0 || student_count <= 0)
		return;

	for(i = 0; i < teacher_count; i++)
	{
		print_teacher_info(pTeacher[i]);
	}

	for(i = 0; i < student_count; i++)
	{
		print_student_info(pStudent[i]);
	}
}

void print_teacher_info(simple_teacher teacher)
{
	printf(" ̸ %s,  %d,  %d\n", 
		teacher.name, teacher.age, teacher.number);
}

void print_student_info(simple_student student)
{
    printf("л ̸: %s, : %d, й: %ld\n", 
            student.name, student.age, student.number);
}
