#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "my_struct.h"
#include "my_func.h"

void add_student(pmy_student pstudent_list)
{
	pmy_student	pcurrent = NULL;
	pmy_student	pprevious = NULL;

	if (NULL == pstudent_list)
	{
		printf(": NULL ޵Ǿϴ\n");
		return;
	}
	pprevious = pstudent_list;
	pcurrent = pstudent_list->pnext;
	while(NULL != pcurrent)
	{
		pprevious = pcurrent;
		pcurrent = pcurrent->pnext;
	}

	pprevious->pnext = (pmy_student) malloc(sizeof(my_student));
	memset(pprevious->pnext, 0, sizeof(my_student));

	input_student_info(pprevious->pnext);
}

void del_student(pmy_student pstudent_list, int del_student_id)
{
	pmy_student	pprevious = NULL;
	pmy_student	pcurrent = NULL;

	if (NULL == pstudent_list)
	{
		printf(": NULL ޵Ǿϴ\n");
		return;
	}

	pprevious = pstudent_list;
	pcurrent = pstudent_list->pnext;
	while(NULL != pcurrent)
	{
		if (pcurrent->id == del_student_id)
		{
			//   ߰.
			pprevious->pnext = pcurrent->pnext;
			free(pcurrent);

			break;
		}

		pprevious = pcurrent;
		pcurrent = pcurrent->pnext;
	}
}

void clear_student_list(pmy_student pstudent_list)
{
	pmy_student	pcurrent = NULL;
	pmy_student	pdel = NULL;

	if (NULL == pstudent_list)
	{
		printf(": NULL ޵Ǿϴ\n");
		return;
	}

	pcurrent = pstudent_list->pnext;
	while(NULL != pcurrent)
	{
		pdel = pcurrent;		
		pcurrent = pcurrent->pnext;

		free(pdel);
	}
}
