#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "my_struct.h"
#include "my_func.h"

void save_to_file(pmy_student pstudent_list, char *file_path)
{
	FILE		*pfile = NULL;
	int			i = 0;
	pmy_student	pcurrent = NULL;

	if (NULL == pstudent_list || NULL == file_path)
	{
		printf(": NULL ޵Ǿϴ\n");
		return;
	}

	pfile = fopen(file_path, "wb");
	if (NULL != pfile) {
		pcurrent = pstudent_list->pnext;
		while(NULL != pcurrent)
		{
			fwrite(pcurrent, sizeof(my_student), 1, pfile);
			pcurrent = pcurrent->pnext;
			i++;
		}

		fclose(pfile);
		printf(" %d л  %s Ǿϴ\n", i, file_path);
	}
 	else {
		printf("[%s],[%s] fopen() ,ڵ: %d\n", file_path, "wb", errno);
	}
}

void load_from_file(pmy_student pstudent_list, char *file_path)
{
	FILE		*pfile = NULL;
	pmy_student	pcurrent = NULL;
	int			i = 0, ret = 0;
	char		buffer[1024] = {0};
	my_student	student = {0};


	if (NULL == pstudent_list || NULL == file_path)
	{
		printf(": NULL ޵Ǿϴ\n");
		return;
	}

	pfile = fopen(file_path, "rb");
	if (NULL != pfile) {
		//   л  Ų.
		clear_student_list(pstudent_list);

		while(1)
		{
			ret = fread(&student, 1, sizeof(my_student), pfile);
			if (0 == ret)
			{
				break;
			}
			else if (ret == sizeof(my_student)) {
				add_student_internal(pstudent_list, student);
			}
			else {
				printf("ü ũ %d ٸϴ\n", sizeof(my_student));
				break;
			}
			i++;
		}
		fclose(pfile);

		printf(" %d л  %s о鿴ϴ\n", i, file_path);
	}
 	else {
		printf("[%s],[%s] fopen() ,ڵ: %d\n", file_path, "rb", errno);
	}
}
