#include <stdio.h>

struct simple_student
{
    char    name[20];
    int     age;
    long    number;
    
    int     score;
};

void print_student_info(struct simple_student* pstudent);
struct simple_student get_max_score_student(struct simple_student *pstudent, int student_count);

int main()
{
	struct simple_student students[] = {
		{"ȫ浿", 20, 1001, 90},
		{"̿", 19, 1002, 50},
		{"浿", 21, 1003, 100}
	};
	struct simple_student student = {0};
	int count = 0;
    
	count = sizeof(students) / sizeof(struct simple_student);
	student = get_max_score_student(students, count);

	printf("ְ   л \n");
	print_student_info(&student);

	return 0;
}

struct simple_student get_max_score_student(struct simple_student *pstudent, int student_count)
{
	struct simple_student result = {0};
	int max_score = 0, max_index = 0, i = 0;

	if (NULL!= pstudent && student_count > 0) 
	{
		max_score = pstudent[0].score;
		max_index = 0;

		for(i = 1; i < student_count; i++)
		{
			if (pstudent[i].score >= max_score)
			{
				max_index = i;
				max_score = pstudent[i].score;
			}
		}

		result = pstudent[max_index];
	}
	else 
	{
		printf("NULL !!!: get_max_score_student()\n");
	}
	return result;
}

void print_student_info(struct simple_student* pstudent)
{
    if (NULL!= pstudent) 
	{
	    printf("̸: %s\n: %d\nй: %ld\n: %d\n", 
            pstudent->name, pstudent->age, pstudent->number, pstudent->score);
	}
	else
	{
		printf("NULL !!!: print_student_info()\n");
	}
}
