#include <stdio.h>

struct simple_point
{
	int		x;
	int		y;
};

struct simple_rectangle
{
	struct simple_point	left_top;
	int		width;
	int		height;
};

void print_rectangle_info(struct simple_rectangle rectangle);
void input_rectangle_info(struct simple_rectangle *pRectangle);

int main()
{
    struct simple_rectangle rectangle = {0};

	input_rectangle_info(&rectangle);
	print_rectangle_info(rectangle);

    return 0;
}

void input_rectangle_info(struct simple_rectangle *pRectangle)
{
    if (NULL!= pRectangle) 
	{
		printf(" (left_top) ġ x? ");
		scanf("%d", &(pRectangle->left_top.x));

		printf(" (left_top) ġ y? ");
		scanf("%d", &(pRectangle->left_top.y));

		printf("̴? ");
		scanf("%d", &(pRectangle->width));

		printf("̴? ");
		scanf("%d", &(pRectangle->height));
    }
    else 
	{
        printf("NULL !!!: input_rectangle_info()\n");
    }
}

void print_rectangle_info(struct simple_rectangle rectangle)
{
    printf("Left-top: (%d, %d)\n", 
		rectangle.left_top.x, rectangle.left_top.y);
    printf("Right-top: (%d, %d)\n", 
		rectangle.left_top.x + rectangle.width, rectangle.left_top.y);
    printf("Left-bottom: (%d, %d)\n", 
		rectangle.left_top.x, rectangle.left_top.y + rectangle.height);
    printf("Right-bottom: (%d, %d)\n", 
		rectangle.left_top.x + rectangle.width, rectangle.left_top.y + rectangle.height);
}

