#include <stdio.h>

typedef enum Class_Type { TYPE_KOR = 10, TYPE_ENG = 20, TYPE_MATH = 30 } Class_Type;

typedef struct _simple_teacher
{
	long			number;
	Class_Type		class_type;
} simple_teacher, *psimple_teacher;

void print_teacher_info(simple_teacher student);

int main()
{
	simple_teacher teacher1 = {1, TYPE_KOR};
	simple_teacher teacher2 = {0};

	teacher2.number = 2;
	teacher2.class_type = TYPE_MATH;
    
	print_teacher_info(teacher1);
	print_teacher_info(teacher2);
    
return 0;
}

char* get_class_type_string(Class_Type grade)
{
	char* presult = NULL;
    
	switch(grade) {
	case TYPE_KOR:
		presult = "";
		break;
	case TYPE_ENG:
		presult = "";
		break;
	case TYPE_MATH:
		presult = "";
		break;
	default:
		presult = "";
		break;
	}
    
	return presult;
}

void print_teacher_info(simple_teacher teacher)
{
	printf(": %ld\t : %s\n", 
		teacher.number, get_class_type_string(teacher.class_type));
}
