#include <stdio.h>

typedef enum _Grade { GRADE_F = 0, GRADE_A = 100, GRADE_B, GRADE_C } Grade;

typedef struct _simple_student
{
    long        number;
    Grade       grade;
} simple_student, *psimple_student;

char get_grade_char(Grade grade);
void print_student_info(simple_student student);

int main()
{
    simple_student student1 = {1, GRADE_A};
    simple_student student2 = {2, GRADE_B};
    simple_student student3 = {3, GRADE_F};

    print_student_info(student1);
    print_student_info(student2);
    print_student_info(student3);
    
    return 0;
}

void print_student_info(simple_student student)
{
    printf("й: %ld\t: %d\n", 
           student.number, student.grade);
}


char get_grade_char(Grade grade)
{
    char result = 'F';
    
    switch(grade) {
        case GRADE_A:
            result = 'A';
            break;
        case GRADE_B:
            result = 'B';
            break;
        case GRADE_C:
            result = 'C';
            break;
        default:
            result = 'F';
            break;
    }
    
    return result;
}

void print_student_info2(simple_student student)
{
    char grade_char = 'F';
    
    printf("й: %ld\t: %c\n", 
           student.number, get_grade_char(student.grade));
}
